/**
 *  Copyright (C) 2004-2005 Savoir-Faire Linux inc.
 *  Author:  Laurielle Lea <laurielle.lea@savoirfairelinux.com>
 *                                                                              
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *                                                                              
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __CODEC_AUDIO_H__
#define __CODEC_AUDIO_H__


#include <string> 
#include "../global.h"

using namespace std;



class AudioCodec {
public:
	AudioCodec(int payload, const string& codec);		
	virtual ~AudioCodec	(void);	

	virtual int	codecDecode	(short *, unsigned char *, unsigned int) = 0;
	virtual int	codecEncode	(unsigned char *, short *, unsigned int) = 0;
	
	void setCodecName (const string& codec);
	string getCodecName (void);
	void float32ToInt16 (float32* src, int16* dst, int size);
	void int16ToFloat32 (int16* src, float32* dst, int size);

private:
	string _codecName;
	int _payload;
};

#endif // __CODEC_AUDIO_H__
